diff --git a/manual/arith.texi b/manual/arith.texi
index eee9880..257c937 100644
--- a/manual/arith.texi
+++ b/manual/arith.texi
@@ -2909,7 +2909,7 @@ See also @ref{Parsing of Integers}.
 The @samp{strfrom} functions are declared in @file{stdlib.h}.
 
 @comment stdlib.h
-@comment ISO/IEC TS 18661-1
+@comment TS 18661-1:2014
 @deftypefun int strfromd (char *restrict @var{string}, size_t @var{size}, const char *restrict @var{format}, double @var{value})
 @comment stdlib.h
 @comment TS 18661-1:2014
diff --git a/manual/conf.texi b/manual/conf.texi
index 78b7a4d..0e1ef51 100644
--- a/manual/conf.texi
+++ b/manual/conf.texi
@@ -787,197 +787,197 @@ Inquire about the number of functions which can be registered as termination
 functions for @code{atexit}; @pxref{Cleanups on Exit}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_VERSION
 Inquire about the parameter corresponding to @code{_XOPEN_VERSION}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_XCU_VERSION
 Inquire about the parameter corresponding to @code{_XOPEN_XCU_VERSION}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_UNIX
 Inquire about the parameter corresponding to @code{_XOPEN_UNIX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_REALTIME
 Inquire about the parameter corresponding to @code{_XOPEN_REALTIME}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_REALTIME_THREADS
 Inquire about the parameter corresponding to @code{_XOPEN_REALTIME_THREADS}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_LEGACY
 Inquire about the parameter corresponding to @code{_XOPEN_LEGACY}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_CRYPT
 Inquire about the parameter corresponding to @code{_XOPEN_CRYPT}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_ENH_I18N
 Inquire about the parameter corresponding to @code{_XOPEN_ENH_I18N}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_SHM
 Inquire about the parameter corresponding to @code{_XOPEN_SHM}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_XPG2
 Inquire about the parameter corresponding to @code{_XOPEN_XPG2}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_XPG3
 Inquire about the parameter corresponding to @code{_XOPEN_XPG3}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_XOPEN_XPG4
 Inquire about the parameter corresponding to @code{_XOPEN_XPG4}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_CHAR_BIT
 Inquire about the number of bits in a variable of type @code{char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_CHAR_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_CHAR_MIN
 Inquire about the minimum value which can be stored in a variable of type
 @code{char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_INT_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_INT_MIN
 Inquire about the minimum value which can be stored in a variable of type
 @code{int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_LONG_BIT
 Inquire about the number of bits in a variable of type @code{long int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_WORD_BIT
 Inquire about the number of bits in a variable of a register word.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_MB_LEN_MAX
 Inquire about the maximum length of a multi-byte representation of a wide
 character value.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NZERO
 Inquire about the value used to internally represent the zero priority level for
 the process execution.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item SC_SSIZE_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{ssize_t}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_SCHAR_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{signed char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_SCHAR_MIN
 Inquire about the minimum value which can be stored in a variable of type
 @code{signed char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_SHRT_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{short int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_SHRT_MIN
 Inquire about the minimum value which can be stored in a variable of type
 @code{short int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_UCHAR_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{unsigned char}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_UINT_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{unsigned int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_ULONG_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{unsigned long int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_USHRT_MAX
 Inquire about the maximum value which can be stored in a variable of type
 @code{unsigned short int}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_ARGMAX
 Inquire about the parameter corresponding to @code{NL_ARGMAX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_LANGMAX
 Inquire about the parameter corresponding to @code{NL_LANGMAX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_MSGMAX
 Inquire about the parameter corresponding to @code{NL_MSGMAX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_NMAX
 Inquire about  the parameter corresponding to @code{NL_NMAX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_SETMAX
 Inquire about the parameter corresponding to @code{NL_SETMAX}.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @item _SC_NL_TEXTMAX
 Inquire about the parameter corresponding to @code{NL_TEXTMAX}.
 @end vtable
diff --git a/manual/creature.texi b/manual/creature.texi
index babec55..5209e0b 100644
--- a/manual/creature.texi
+++ b/manual/creature.texi
@@ -73,10 +73,10 @@ edition is made available.
 @end defvr
 
 @comment (none)
-@comment X/Open
+@comment XOPEN
 @defvr Macro _XOPEN_SOURCE
 @comment (none)
-@comment X/Open
+@comment XOPEN
 @defvrx Macro _XOPEN_SOURCE_EXTENDED
 If you define this macro, functionality described in the X/Open
 Portability Guide is included.  This is a superset of the POSIX.1 and
@@ -96,7 +96,7 @@ Single Unix Specification, @w{version 2}.
 @end defvr
 
 @comment (NONE)
-@comment X/Open
+@comment XOPEN
 @defvr Macro _LARGEFILE_SOURCE
 If this macro is defined some extra functions are available which
 rectify a few shortcomings in all previous standards.  Specifically,
@@ -109,7 +109,7 @@ This macro was introduced as part of the Large File Support extension (LFS).
 @end defvr
 
 @comment (NONE)
-@comment X/Open
+@comment XOPEN
 @defvr Macro _LARGEFILE64_SOURCE
 If you define this macro an additional set of functions is made available
 which enables @w{32 bit} systems to use files of sizes beyond
@@ -129,7 +129,7 @@ offsets are not generally used (see @code{_FILE_OFFSET_BITS}).
 @end defvr
 
 @comment (NONE)
-@comment X/Open
+@comment XOPEN
 @defvr Macro _FILE_OFFSET_BITS
 This macro determines which file system interface shall be used, one
 replacing the other.  Whereas @code{_LARGEFILE64_SOURCE} makes the @w{64
diff --git a/manual/filesys.texi b/manual/filesys.texi
index 8ddb8b7..0ccc86c 100644
--- a/manual/filesys.texi
+++ b/manual/filesys.texi
@@ -721,7 +721,7 @@ entries in a directory, possibly sort them and get a list of names as
 the result.
 
 @comment dirent.h
-@comment BSD/SVID
+@comment BSD, SVID
 @deftypefun int scandir (const char *@var{dir}, struct dirent ***@var{namelist}, int (*@var{selector}) (const struct dirent *), int (*@var{cmp}) (const struct dirent **, const struct dirent **))
 @safety{@prelim{}@mtsafe{}@asunsafe{@ascuheap{}}@acunsafe{@acsmem{} @acsfd{}}}
 @c The scandir function calls __opendirat, __readdir, and __closedir to
@@ -764,7 +764,7 @@ programmer @theglibc{} contains implementations of functions which
 are very helpful for this purpose.
 
 @comment dirent.h
-@comment BSD/SVID
+@comment BSD, SVID
 @deftypefun int alphasort (const struct dirent **@var{a}, const struct dirent **@var{b})
 @safety{@prelim{}@mtsafe{@mtslocale{}}@asunsafe{@ascuheap{}}@acunsafe{@acsmem{}}}
 @c Calls strcoll.
@@ -3071,7 +3071,7 @@ Using these functions on anything other than a regular file gives
 succeed, without actually accomplishing anything.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @deftypefun int truncate (const char *@var{filename}, off_t @var{length})
 @safety{@prelim{}@mtsafe{}@assafe{}@acsafe{}}
 @c In the absence of a truncate syscall, we use open and ftruncate.
diff --git a/manual/llio.texi b/manual/llio.texi
index dfefd4d..974cbf4 100644
--- a/manual/llio.texi
+++ b/manual/llio.texi
@@ -1857,7 +1857,7 @@ special functions which ensure that all operations finish before
 they return.
 
 @comment unistd.h
-@comment X/Open
+@comment XOPEN
 @deftypefun void sync (void)
 @safety{@prelim{}@mtsafe{}@assafe{}@acsafe{}}
 A call to this function will not return as long as there is data which
diff --git a/manual/message.texi b/manual/message.texi
index 21317b3..ff4caec 100644
--- a/manual/message.texi
+++ b/manual/message.texi
@@ -84,7 +84,7 @@ are defined/declared in the @file{nl_types.h} header file.
 @subsection The @code{catgets} function family
 
 @comment nl_types.h
-@comment X/Open
+@comment XOPEN
 @deftypefun nl_catd catopen (const char *@var{cat_name}, int @var{flag})
 @safety{@prelim{}@mtsafe{@mtsenv{}}@asunsafe{@ascuheap{}}@acunsafe{@acsmem{}}}
 @c catopen @mtsenv @ascuheap @acsmem
diff --git a/manual/resource.texi b/manual/resource.texi
index 2132e06..08c342b 100644
--- a/manual/resource.texi
+++ b/manual/resource.texi
@@ -1188,7 +1188,7 @@ The highest valid nice value.
 @end vtable
 
 @comment sys/resource.h
-@comment BSD,POSIX
+@comment BSD, POSIX
 @deftypefun int getpriority (int @var{class}, int @var{id})
 @safety{@prelim{}@mtsafe{}@assafe{}@acsafe{}}
 @c Direct syscall on UNIX.  On HURD, calls _hurd_priority_which_map.
@@ -1217,7 +1217,7 @@ afterward as the criterion for failure.
 @end deftypefun
 
 @comment sys/resource.h
-@comment BSD,POSIX
+@comment BSD, POSIX
 @deftypefun int setpriority (int @var{class}, int @var{id}, int @var{niceval})
 @safety{@prelim{}@mtsafe{}@assafe{}@acsafe{}}
 @c Direct syscall on UNIX.  On HURD, calls _hurd_priority_which_map.
diff --git a/manual/socket.texi b/manual/socket.texi
index 32073fb..c494cdf 100644
--- a/manual/socket.texi
+++ b/manual/socket.texi
@@ -500,7 +500,7 @@ interface name, including its terminating zero byte.
 @end deftypevr
 
 @comment net/if.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun {unsigned int} if_nametoindex (const char *@var{ifname})
 @safety{@prelim{}@mtsafe{}@asunsafe{@asulock{}}@acunsafe{@aculock{} @acsfd{}}}
 @c It opens a socket to use ioctl on the fd to get the index.
@@ -515,7 +515,7 @@ name.  If no interface exists with the name given, it returns 0.
 @end deftypefun
 
 @comment net/if.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun {char *} if_indextoname (unsigned int @var{ifindex}, char *@var{ifname})
 @safety{@prelim{}@mtsafe{}@asunsafe{@asulock{}}@acunsafe{@aculock{} @acsfd{}}}
 @c It opens a socket with opensock to use ioctl on the fd to get the
@@ -528,7 +528,7 @@ invalid, the function's return value is a null pointer, otherwise it is
 @end deftypefun
 
 @comment net/if.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftp {Data Type} {struct if_nameindex}
 This data type is used to hold the information about a single
 interface.  It has the following members:
@@ -544,7 +544,7 @@ This is the null-terminated index name.
 @end deftp
 
 @comment net/if.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun {struct if_nameindex *} if_nameindex (void)
 @safety{@prelim{}@mtsafe{}@asunsafe{@ascuheap{} @asulock{/hurd}}@acunsafe{@aculock{/hurd} @acsfd{} @acsmem{}}}
 @c if_nameindex @ascuheap @asulock/hurd @aculock/hurd @acsfd @acsmem
@@ -589,7 +589,7 @@ use.
 @end deftypefun
 
 @comment net/if.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun void if_freenameindex (struct if_nameindex *@var{ptr})
 @safety{@prelim{}@mtsafe{}@asunsafe{@ascuheap{}}@acunsafe{@acsmem{}}}
 @c if_freenameindex @ascuheap @acsmem
@@ -749,7 +749,7 @@ protocols.
 @end deftypevr
 
 @comment sys/socket.h
-@comment X/Open
+@comment XOPEN
 @deftypevr Macro int PF_INET6
 This designates the IPv6 Internet namespace and associated family of
 protocols.
@@ -1048,14 +1048,14 @@ This constant is returned by some functions to indicate an error.
 @end deftypevr
 
 @comment netinet/in.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftp {Data Type} {struct in6_addr}
 This data type is used to store an IPv6 address.  It stores 128 bits of
 data, which can be accessed (via a union) in a variety of ways.
 @end deftp
 
 @comment netinet/in.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypevr Constant {struct in6_addr} in6addr_loopback
 This constant is the IPv6 address @samp{::1}, the loopback address.  See
 above for a description of what this means.  The macro
@@ -1064,7 +1064,7 @@ own variables to this value.
 @end deftypevr
 
 @comment netinet/in.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypevr Constant {struct in6_addr} in6addr_any
 This constant is the IPv6 address @samp{::}, the unspecified address.  See
 above for a description of what this means.  The macro
@@ -1199,7 +1199,7 @@ anymore.
 @end deftypefun
 
 @comment arpa/inet.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun int inet_pton (int @var{af}, const char *@var{cp}, void *@var{buf})
 @safety{@prelim{}@mtsafe{@mtslocale{}}@assafe{}@acsafe{}}
 @c inet_pton @mtslocale
@@ -1220,7 +1220,7 @@ responsibility to make sure the buffer is large enough.
 @end deftypefun
 
 @comment arpa/inet.h
-@comment IPv6 basic API
+@comment IPv6 Basic API
 @deftypefun {const char *} inet_ntop (int @var{af}, const void *@var{cp}, char *@var{buf}, socklen_t @var{len})
 @safety{@prelim{}@mtsafe{@mtslocale{}}@assafe{}@acsafe{}}
 @c inet_ntop @mtslocale
diff --git a/manual/string.texi b/manual/string.texi
index 683a20f..fdf2e55 100644
--- a/manual/string.texi
+++ b/manual/string.texi
@@ -599,7 +599,7 @@ This function is a GNU extension.
 @end deftypefun
 
 @comment string.h
-@comment Unknown origin
+@comment POSIX.1-2008
 @deftypefun {char *} stpcpy (char *restrict @var{to}, const char *restrict @var{from})
 @safety{@prelim{}@mtsafe{}@assafe{}@acsafe{}}
 This function is like @code{strcpy}, except that it returns a pointer to
diff --git a/manual/time.texi b/manual/time.texi
index bad9ce6..b093168 100644
--- a/manual/time.texi
+++ b/manual/time.texi
@@ -1655,7 +1655,7 @@ For an example of @code{strftime}, see @ref{Time Functions Example}.
 @end deftypefun
 
 @comment time.h
-@comment ISO/Amend1
+@comment C95
 @deftypefun size_t wcsftime (wchar_t *@var{s}, size_t @var{size}, const wchar_t *@var{template}, const struct tm *@var{brokentime})
 @safety{@prelim{}@mtsafe{@mtsenv{} @mtslocale{}}@asunsafe{@asucorrupt{} @ascuheap{} @asulock{} @ascudlopen{}}@acunsafe{@acucorrupt{} @aculock{} @acsmem{} @acsfd{}}}
 @c wcsftime @mtsenv @mtslocale @asucorrupt @ascuheap @asulock @ascudlopen @acucorrupt @aculock @acsmem @acsfd